//+------------------------------------------------------------------+
//|                                            WhiteHorse Sto EA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

extern int UpperLine   =80;
extern int LowerLine   =20;
extern int StoK        =5;
extern int StoD        =3;
extern int StoS        =3;
extern ENUM_MA_METHOD MAMethod    =0; // 0 is MAIN, and 1 is SIGNAL.
extern ENUM_STO_PRICE pricefield  =0; // 0 is Low/High, 1 is Close/Close.
extern string MODEs    =" =0 is MAIN,1 is SIGNAL.";
extern int    MODE        =0;
extern double SL       =100;
extern double TP       =100;
extern double lTrailingStop = 50;
extern double sTrailingStop = 50;
extern double Lots     =0.1;
extern int    MaxTrades   =1;

extern int magic = 2;
extern bool ShowAlerts = false;

double   pipMultiplier = 1;
double   pPoint;
string   s_symbol;
int      digit;
bool     dummyResult;
//+------------------------------------------------------------------+
int init()
{
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
  
   if(TP < MarketInfo(s_symbol,MODE_STOPLEVEL) || SL < MarketInfo(s_symbol,MODE_STOPLEVEL) )
   {
      Alert("SL or TP are to low. The broker\'s minimum stoplevel is "+ MarketInfo(Symbol(),MODE_STOPLEVEL));
      return(-1);
   }
   
   if(Lots>MarketInfo(s_symbol,MODE_MAXLOT))
      Lots=MarketInfo(s_symbol,MODE_MAXLOT);
   if(Lots<MarketInfo(s_symbol,MODE_MINLOT))
      Lots=MarketInfo(s_symbol,MODE_MINLOT);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double Sto =iStochastic(Symbol(),0,StoK,StoD,StoS,MAMethod,pricefield,MODE,0);
   bool trade = true; // true if no open trade on this Pair exists with the same magic number

   int openOrders = OpenPositions(trade); 
                       
   if(openOrders<MaxTrades && Sto >= UpperLine && trade) {
      RefreshRates();
      dummyResult = OrderSend(s_symbol, OP_BUY,  Lots,  Ask,3,NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)-SL*pPoint*pipMultiplier,digit), NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)+TP*pPoint*pipMultiplier,digit), NULL, magic, 0, CLR_NONE);
     }
   if(openOrders<MaxTrades && Sto <= LowerLine && trade) {
      RefreshRates();
      dummyResult = OrderSend(s_symbol, OP_SELL,  Lots,  Bid,3,NormalizeDouble(MarketInfo(s_symbol,MODE_BID)+SL*pPoint*pipMultiplier,digit), NormalizeDouble(MarketInfo(s_symbol,MODE_BID)-TP*pPoint*pipMultiplier,digit), NULL, magic, 0, CLR_NONE);
     }
   if (lTrailingStop > 0)  TrailingPositionsBuy();
   if (sTrailingStop > 0)  TrailingPositionsSell();
   return(0);
  }
//+------------------------------------------------------------------+


int OpenPositions(bool& trade){ // returns number of active positions.
   int trades=0;
   
   while(IsTradeContextBusy()) Sleep(50);

   for(int i = OrdersTotal()-1; i >= 0; i--) 
   {
      if( OrderSelect(i, SELECT_BY_POS) && OrderMagicNumber() == magic) 
      {  
         if (OrderSymbol() == s_symbol) trade = false;
         if (OrderType()==OP_BUY) trades++;
         if (OrderType()==OP_SELL)trades++;
      }  
   }
   return(trades);
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   double pBid = Bid; 
   for (int i = OrdersTotal()-1; i >=0 ; i--) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == magic) { 
            if (OrderType() == OP_BUY) { 
               if (pBid - OrderOpenPrice()   > lTrailingStop  * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() < pBid  - lTrailingStop * pPoint * pipMultiplier) 
                    ModifyStopLoss(     pBid  - lTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   double pAsk = Ask; 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == magic) { 
            if (OrderType() == OP_SELL) { 
                if (OrderOpenPrice()  - pAsk > sTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() > pAsk + sTrailingStop * pPoint * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(   pAsk + sTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   double minStop = 0;
   double pBid    = Bid;
   double pAsk    = Ask;
   double sl      = MarketInfo(s_symbol,MODE_STOPLEVEL);   
   bool   canGo   = false;
      if (OrderType()==OP_BUY)
            { minStop = pBid-sl*pPoint; canGo = ldStopLoss<=minStop; }
      else  { minStop = pAsk+sl*pPoint; canGo = ldStopLoss>=minStop; }
      if (canGo)
      {
        fm = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(ldStopLoss,digit),NormalizeDouble(OrderTakeProfit(),digit),0,CLR_NONE); 
        if (fm == false)
        {
	        int    ErrorCode = GetLastError();
	        string ErrDesc   = ErrorDescription(ErrorCode);
	        string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
   	        if (ShowAlerts   == true) Alert(ErrAlert);
            	  string ErrLog = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
      	  Print(ErrLog);
      	}
      }      	
      else Print("Stop loss to close to current price");

}  